{
 "cells": [
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "# The dictionary data structure\n",
    "d = {} \n",
    "\n",
    "key = 'A'\n",
    "k2 = 'B'\n",
    "value = 3\n",
    "v2 = 2\n",
    "v3 = 1\n",
    "\n",
    "# Change Value / Insert\n",
    "d[key] = value # If key not in dictionary is added to dictionary\n",
    "d[k2] = v2\n",
    "d[key] = v3 # if key in dictionary, value is updated\n",
    "\n",
    "print(d)\n",
    "\n",
    "# Remove value\n",
    "d.pop(k2)\n",
    "\n",
    "# Get Value\n",
    "print(d[key])"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {},
   "outputs": [],
   "source": [
    "class bstNode:\n",
    "    def __init__(self, key, val, left=None, right=None):\n",
    "        self.key = key\n",
    "        self.val = val\n",
    "        self.left = left\n",
    "        self.right = right\n",
    "\n",
    "# INPUT:\n",
    "# A treeNode object storing the root of the tree being measured (node)\n",
    "# OUTPUT:\n",
    "# An integer storing the height of the tree defined by root\n",
    "# Hint: A recursive solution is easiest (as seen in class)!\n",
    "def height(node):\n",
    "    if node == None:\n",
    "        return -1\n",
    "\n",
    "    return 1 + max(height(node.left), height(node.right))\n",
    "\n",
    "# INPUT:\n",
    "# A treeNode object storing the root of the tree being printed (root)\n",
    "# OUTPUT:\n",
    "# Nothing\n",
    "# Prints to terminal an ASCII interpretation of the graph\n",
    "# IMPORTANT: Requires a functional implementation of height!\n",
    "def printTree(root):\n",
    "    if root == None:\n",
    "        print(\"(empty)\\n\")\n",
    "        return\n",
    "\n",
    "    root_height = height(root)\n",
    "    print_matrix_width = (4 << root_height) - 3\n",
    "    print_matrix_height = 2 * root_height + 1\n",
    "\n",
    "    output = [None]*print_matrix_height\n",
    "    for i in range(len(output)):\n",
    "        output[i] = [' '] * (print_matrix_width+4)\n",
    "\n",
    "    pt_helper(root, output, 0, 0, print_matrix_width)\n",
    "\n",
    "    for row in output:\n",
    "        print(\"\".join(row))\n",
    "\n",
    "\n",
    "def pt_helper(root, output, left, top, curr_width):\n",
    "    val = [char for char in str(root.val)]\n",
    "    curr_width = int(curr_width)\n",
    "\n",
    "    left_start_shift = int(1 - (len(val)-1) / 2)\n",
    "    i = 0\n",
    "    while (i < len(val) and left + curr_width/2 + i < len(output[top])):\n",
    "        output[top][int(left + curr_width/2 +\n",
    "                        left_start_shift + i)] = val[i]\n",
    "        i += 1\n",
    "\n",
    "    branchOffset = (curr_width+3) >> 3\n",
    "    branchOffset = int(branchOffset)\n",
    "\n",
    "    center = int(left + curr_width/2)\n",
    "    leftcenter = int(left + (curr_width/2 - 1)/2)\n",
    "    rightcenter = int(left + curr_width/2 + 2 + (curr_width/2 - 1)/2)\n",
    "\n",
    "    if root.left != None:\n",
    "        branch_pos = center - branchOffset + 1\n",
    "\n",
    "        for pos in range(int(center+left_start_shift - 2), branch_pos, -1):\n",
    "            output[top][pos] = '_'\n",
    "\n",
    "        output[top+1][branch_pos] = '/'\n",
    "\n",
    "        for pos in range(branch_pos-1, leftcenter + 2, -1):\n",
    "            output[top+1][pos] = '_'\n",
    "\n",
    "        pt_helper(root.left, output, left, top+2, curr_width/2 - 1)\n",
    "\n",
    "    if root.right != None:\n",
    "        branch_pos = center + branchOffset + 1\n",
    "\n",
    "        for pos in range(center+left_start_shift + len(val) + 1, branch_pos, 1):\n",
    "            output[top][pos] = '_'\n",
    "\n",
    "        output[top+1][branch_pos] = '\\\\'\n",
    "\n",
    "        for pos in range(branch_pos+1, rightcenter, 1):\n",
    "            output[top+1][pos] = '_'\n",
    "\n",
    "        pt_helper(root.right, output, left +\n",
    "                  curr_width/2 + 2, top+2, curr_width/2 - 1)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "metadata": {},
   "outputs": [],
   "source": [
    "class bst:\n",
    "    def __init__(self, root=None):\n",
    "        self.root = root\n",
    "\n",
    "    def insert(self, key, val):\n",
    "        self.root = self.insert_helper(self.root, key, val)\n",
    "\n",
    "\n",
    "    # This is insert but with NODE!\n",
    "    # Node lets us track our 'current' position in the tree!\n",
    "    # It starts at the root of our full tree\n",
    "    def insert_helper(self, node, key, val):\n",
    "        # Base Case\n",
    "        if node == None:\n",
    "            # My new node should be RIGHT HERE!\n",
    "            return bstNode(key, val)\n",
    "        # Recursive Step\n",
    "        if key > node.key: # key is my new key, node.key is my CURRENT key\n",
    "            # If I am larger, go right!\n",
    "            node.right = self.insert_helper(node.right, key, val)\n",
    "        elif key < node.key:\n",
    "            # if I am smaller, go left!\n",
    "            node.left = self.insert_helper(node.left, key, val)\n",
    "    \n",
    "        # Combining step\n",
    "        return node\n",
    "\n",
    "    def find(self, key):\n",
    "        # Calling a helper function that starts at root.\n",
    "        n = self.find_helper(self.root, key)\n",
    "        if n:\n",
    "            return n.val\n",
    "        else:\n",
    "            return None\n",
    "\n",
    "    def find_helper(self, node, key):\n",
    "        # Base Case\n",
    "        if node == None:\n",
    "            return None\n",
    "        # Recurse\n",
    "        if node.key == key:\n",
    "            return node\n",
    "        if key > node.key:\n",
    "            return self.find_helper(node.right, key)\n",
    "        if key < node.key:\n",
    "            return self.find_helper(node.left, key)\n",
    "        # Combine (But this line never happens -- combine is RETURN)\n",
    "        print(\"Hello!\")\n",
    "\n",
    "    def remove(self, key):\n",
    "        self.root = self.remove_helper(self.root, key)\n",
    "\n",
    "    def remove_helper(self, node, key):\n",
    "        pass\n",
    "\n",
    "    def findIOP(self, node):\n",
    "        pass\n",
    "\n",
    "    def findIOS(self, node):\n",
    "        pass"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 14,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      " A   \n",
      "*****\n",
      "            __ A __              \n",
      "         __/       \\___          \n",
      "       B                C        \n",
      "     /                    \\      \n",
      "   E                        D    \n",
      "  / \\                            \n",
      " G    F                          \n",
      "*****\n",
      "*****\n",
      "F\n"
     ]
    }
   ],
   "source": [
    "bst1 = bst()\n",
    "bst1.insert(4, \"A\")\n",
    "\n",
    "printTree(bst1.root)\n",
    "print(\"*****\")\n",
    "bst1.insert(3, \"B\")\n",
    "bst1.insert(5,\"C\")\n",
    "bst1.insert(6, \"D\")\n",
    "bst1.insert(1,\"E\")\n",
    "bst1.insert(2, \"F\")\n",
    "bst1.insert(0, \"G\")\n",
    "\n",
    "printTree(bst1.root)\n",
    "print(\"*****\")\n",
    "\n",
    "#bst1.remove(4)\n",
    "#printTree(bst1.root)\n",
    "print(\"*****\")\n",
    "print(bst1.find(2))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": []
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3 (ipykernel)",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.11.0"
  },
  "vscode": {
   "interpreter": {
    "hash": "1a1af0ee75eeea9e2e1ee996c87e7a2b11a0bebd85af04bb136d915cefc0abce"
   }
  }
 },
 "nbformat": 4,
 "nbformat_minor": 4
}
